'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6643] on 10 April 2005 at 7:16:30 pm'!
"Change Set:		StringRefs
Date:			10 April 2005
Author:			Andreas Raab

Add some support for browsing the (non-trivial) references to String. For finding those execute:
	String browseNonTrivialStringRefs.
In my current image those are 23 compared to 721 (mostly trivial) references to String itself.
"!


!AbstractString class methodsFor: 'porting' stamp: 'ar 4/10/2005 18:50'!
browseNonTrivialStringRefs
	"
		String browseNonTrivialStringRefs
	"
	| selectorList list classString meth skipThis added |
	selectorList := IdentitySet withAll: #(
		streamContents: 
		streamContents:limitedTo:
		new 
		new: 
		with:
		with:with:
		with:with:with:
		with:with:with:with:
		withAll:
		new:withAll:
		cr
		lf
		crlf
		crlfcrlf
		tab
		value:
	).
	list := SortedCollection new.
	classString := Smalltalk associationAt: #String.
	SystemNavigation new allBehaviorsDo:[:cls|
		cls selectorsAndMethodsDo:[:sel :cm|
			(cm hasLiteralThorough: classString) ifTrue:[
				meth := cls class parserClass new parse: (cls sourceCodeAt: sel) class: cls.
				skipThis := added := false.
				meth nodesDo:[:node|
					(node isVariableNode and:[node name = 'String']) ifTrue:[
						(skipThis or:[added]) ifFalse:[
							list add: (MethodReference new setStandardClass: cls methodSymbol: sel).
							added := true.
						].
					].
					skipThis := false.
					node isMessageNode ifTrue:[
						((selectorList includes: node selector asSymbol) 
							and:[node receiver notNil
							and:[node receiver isVariableNode
							and:[node receiver name = 'String']]]) ifTrue:[skipThis := true].
					].
				].
			].
		].
	].
	SystemNavigation new browseMessageList: list name: 'String refs' autoSelect:'String'.
! !


!ParseNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:20'!
nodesDo: aBlock
	aBlock value: self.! !

!ParseNode methodsFor: 'testing' stamp: 'ar 4/10/2005 18:20'!
isLiteralVariableNode
	^false! !

!ParseNode methodsFor: 'testing' stamp: 'ar 4/10/2005 18:27'!
isMessageNode
	^false! !

!ParseNode methodsFor: 'testing' stamp: 'ar 4/10/2005 18:20'!
isMethodNode
	^false! !

!ParseNode methodsFor: 'testing' stamp: 'ar 4/10/2005 18:23'!
isVariableNode
	^false! !


!AssignmentNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:21'!
nodesDo: aBlock
	aBlock value: self.
	variable nodesDo: aBlock.
	value nodesDo: aBlock.! !


!BlockNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:21'!
nodesDo: aBlock
	aBlock value: self.
	statements do:[:each| each nodesDo: aBlock].! !


!BraceNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:22'!
nodesDo: aBlock
	aBlock value: self.
	elements do:[:each| each nodesDo: aBlock].! !


!CascadeNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:31'!
nodesDo: aBlock
	aBlock value: self.
	receiver nodesDo: aBlock.
	messages do:[:each| each nodesDo: aBlock].! !


!MessageNode methodsFor: 'testing' stamp: 'ar 4/10/2005 18:27'!
isMessageNode
	^true! !

!MessageNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:32'!
nodesDo: aBlock
	aBlock value: self.
	receiver ifNotNil:[receiver nodesDo: aBlock]. "cascade nodes may have nil receiver"
	arguments do:[:each| each ifNotNil:[each nodesDo: aBlock]]. "transformed msgs can have nil"! !


!MethodNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:30'!
nodesDo: aBlock
	aBlock value: self.
	block nodesDo: aBlock.! !


!ReturnNode methodsFor: 'enumerating' stamp: 'ar 4/10/2005 18:24'!
nodesDo: aBlock
	aBlock value: self.
	expr nodesDo: aBlock.! !


!SelectorNode methodsFor: 'converting' stamp: 'ar 4/10/2005 18:33'!
asSymbol
	^key! !


!VariableNode methodsFor: 'testing' stamp: 'ar 4/10/2005 18:23'!
isVariableNode

	^true! !


!LiteralVariableNode methodsFor: 'testing' stamp: 'ar 4/10/2005 18:23'!
isLiteralVariableNode
	^true! !


!LiteralVariableNode reorganize!
('code generation' emitLoad:on: emitStore:on: emitStorePop:on: sizeForStore: sizeForStorePop:)
('testing' isLiteralVariableNode)
!


!SelectorNode reorganize!
('code generation' emit:args:on: emit:args:on:super: size:args:super:)
('printing' printOn:indent:)
('inappropriate' emitForEffect:on: emitForValue:on: sizeForEffect: sizeForValue:)
('testing' isPvtSelector)
('converting' asSymbol)
!


!ReturnNode reorganize!
('initialize-release' expr: expr:encoder:sourceRange:)
('converting' asReturnNode)
('testing' isReturnSelf isSpecialConstant isVariableReference)
('code generation' code emitForReturn:on: emitForValue:on: sizeForReturn: sizeForValue:)
('printing' expr printOn:indent:)
('tiles' asMorphicSyntaxIn: explanation)
('enumerating' nodesDo:)
!


!MethodNode reorganize!
('initialize-release' block selector: selector:arguments:precedence:temporaries:block:encoder:primitive: sourceText:)
('code generation' encoder generate: generate:ifQuick: generateNative: parserClass selector sourceMap)
('converting' asAltSyntaxText asColorizedSmalltalk80Text decompileString decompileText)
('printing' methodClass printOn: printPrimitiveOn: sourceText tempNames)
('tiles' asMorphicSyntaxIn: asMorphicSyntaxUsing: rawSourceRanges)
('enumerating' nodesDo:)
!


!MessageNode reorganize!
('initialize-release' receiver:selector:arguments:precedence: receiver:selector:arguments:precedence:from: receiver:selector:arguments:precedence:from:sourceRange: selector:)
('testing' canCascade isComplex isMessageNode isMessage:receiver:arguments: isReturningIf toDoIncrement: toDoLimit:)
('cascading' cascadeReceiver)
('macro transformations' noteSpecialSelector: toDoFromWhileWithInit: transform: transformAnd: transformBoolean: transformIfFalse: transformIfFalseIfTrue: transformIfNil: transformIfNilIfNotNil: transformIfNotNilIfNil: transformIfTrue: transformIfTrueIfFalse: transformOr: transformToDo: transformWhile:)
('code generation' emitCase:on:value: emitForEffect:on: emitForValue:on: emitIf:on:value: emitIfNil:on:value: emitToDo:on:value: emitWhile:on:value: sizeCase:value: sizeForEffect: sizeForValue: sizeIf:value: sizeIfNil:value: sizeToDo:value: sizeWhile:value:)
('printing' asMorphicCaseOn:indent: macroPrinter precedence printCaseOn:indent: printIfNil:indent: printIfNilNotNil:indent: printIfOn:indent: printKeywords:arguments:on:indent: printKeywords:arguments:on:indent:prefix: printOn:indent: printOn:indent:precedence: printParenReceiver:on:indent: printReceiver:on:indent: printToDoOn:indent: printWhileOn:indent: test)
('private' checkBlock:as:from: ifNilReceiver pvtCheckForPvtSelector: receiver:arguments:precedence: transformCase:)
('equation translation' arguments arguments: eval receiver receiver: selector)
('tiles' asMorphicSyntaxIn: morphFromKeywords:arguments:on:indent:)
('enumerating' nodesDo:)
!


!CascadeNode reorganize!
('initialize-release' receiver:messages:)
('code generation' emitForValue:on: sizeForValue:)
('printing' printOn:indent: printOn:indent:precedence:)
('tiles' asMorphicSyntaxIn:)
('accessing' receiver)
('enumerating' nodesDo:)
!


!BlockNode reorganize!
('initialize-release' arguments:statements:returns:from: arguments:statements:returns:from:sourceRange: statements:returns:)
('accessing' arguments: block firstArgument numberOfArguments returnLast returnSelfIfNoOther temporaries:)
('testing' canBeSpecialArgument isComplex isJust: isJustCaseError isQuick returns)
('code generation' code emitExceptLast:on: emitForEvaluatedEffect:on: emitForEvaluatedValue:on: emitForValue:on: sizeExceptLast: sizeForEvaluatedEffect: sizeForEvaluatedValue: sizeForValue:)
('printing' printArgumentsOn:indent: printOn:indent: printStatementsOn:indent: printTemporariesOn:indent:)
('equation translation' statements statements:)
('tiles' asMorphicCollectSyntaxIn: asMorphicSyntaxIn:)
('enumerating' nodesDo:)
!


!AssignmentNode reorganize!
('initialize-release' toDoIncrement: value variable:value: variable:value:from: variable:value:from:sourceRange:)
('code generation' emitForEffect:on: emitForValue:on: sizeForEffect: sizeForValue:)
('printing' printOn:indent: printOn:indent:precedence:)
('equation translation' variable)
('tiles' asMorphicSyntaxIn: explanation)
('enumerating' nodesDo:)
!


!ParseNode reorganize!
('enumerating' nodesDo:)
('testing' assignmentCheck:at: canBeSpecialArgument canCascade isArg isComplex isConstantNumber isJust: isLiteral isLiteralVariableNode isMessageNode isMessage:receiver:arguments: isMethodNode isReturnSelf isReturningIf isSelfPseudoVariable isSpecialConstant isTemp isUndefTemp isUnusedTemp isVariableNode isVariableReference nowHasDef nowHasRef toDoIncrement:)
('code generation' emitBranchOn:dist:pop:on: emitForEffect:on: emitForReturn:on: emitJump:on: emitLong:code:on: emitShortOrLong:code:on: pc sizeBranchOn:dist: sizeForEffect: sizeForReturn: sizeJump: sizeShortOrLong:)
('encoding' encodeSelector:)
('comment' comment comment:)
('converting' asReturnNode)
('printing' nodePrintOn:indent: printCommentOn:indent: printOn: printOn:indent: printOn:indent:precedence:)
('private' ifNilReceiver nextWordFrom:setCharacter: printSingleComment:on:indent:)
('tiles' addCommentToMorph: asMorphicSyntaxIn: currentValueIn: explanation)
!


!AbstractString class reorganize!
('instance creation' correspondingSymbolClass cr crlf crlfcrlf fromByteArray: fromPacked: fromString: lf new: readFrom: tab value: with:)
('initialization' initialize initializeHtmlEntities)
('examples' example)
('utilities')
('primitives' findFirstInString:inSet:startingAt: indexOfAscii:inString:startingAt: stringHash:initialHash: translate:from:to:table:)
('plugin generation' ccgDeclareCForVar: ccg:prolog:expr:index:)
('porting' browseNonTrivialStringRefs)
!

